//More information at: https://www.aeq-web.com?ref=arduinoide


#define FASTADC 1
#ifndef cbi
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#endif
#ifndef sbi
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#endif


int data = 512;
int storage[512];

long FlashStart;
long FlashEnd;
long tmr;
int reading;
int count;
int maximum;
int minimum;
bool toSend;

void setup() {
#if FASTADC
  sbi(ADCSRA, ADPS2) ;
  cbi(ADCSRA, ADPS1) ;
  cbi(ADCSRA, ADPS0) ;
#endif

  Serial.begin(9600);
  pinMode(A5, INPUT);
  Serial.println(micros());

  FlashStart = 0;
  FlashEnd = 0;
  reading = 0;
  count = 0;
  maximum = 0;
  minimum = 1023;
  toSend = false;
  tmr = millis();
}


void loop() {
  reading = (analogRead(A5));
  storage[count] = reading;
  if ((!toSend) && (count != 0) && ((reading > storage[count - 1] + 10) || (reading < storage[count - 1] - 10))) {
    toSend = true;
  }

  count = count + 1;
  if ((count == 512) && (toSend))
  {
    count = 0;
    FlashEnd = millis();
    sendData();
    FlashStart = millis();

  }
  else if (count == 512) {
    count = 0;
    FlashEnd = millis();
    FlashStart = millis();

  }


}

void sendData()
{
  int getout;
  for (int i = 0; i < data; i++) {
    getout = storage[i];
  }
  double tm = ((millis() - tmr) / 1000);
  Serial.print("Flash Value: ");
  Serial.print(getout);
  Serial.print(" - Last Flash: ");
  Serial.print(tm);
  Serial.println(" sec");
  tmr = millis();
  toSend = false;
}
